import { select, range } from 'd3';

const svg = select('svg');
const width = svg.attr('width');
const height = svg.attr('height');
const centerX = width / 2;
const centerY = height / 2;

const bottomLineLength = width * 0.8;
const bottomMargin = 20;

const leftLineLength = height * 0.9;
const leftMargin = 100;

//Rects
const rectWidth = 50;
const rectHeights = [200, 300, 400];
const numRects = rectHeights.length;

//Bottom line
const bottomLine = {
    x1: centerX - (bottomLineLength / 2),
    x2: centerX + (bottomLineLength / 2),
    y1: height - bottomMargin,
    y2: height - bottomMargin,
  };

//Left line
const leftLine = {
    x1: leftMargin,
    x2: leftMargin,
    y1: centerY - leftLineLength / 2,
    y2: centerY + leftLineLength / 2
  };

const rects = range(numRects)
  .map(i => {
    return {
   	  width: rectWidth,
      height: rectHeights[i],
      x: leftMargin + (bottomLineLength/(numRects+2))*(i+1)
         + (rectWidth/2),
      y: height - bottomMargin - rectHeights[i]
    }});
    

svg.selectAll('rect').data(rects)
  .enter().append('rect')
    .attr('width', d => d.width)
    .attr('height', d => d.height)
    .attr('x', d => d.x)
    .attr('y', d => d.y);

svg.selectAll('line').data([bottomLine, leftLine])
  .enter().append('line')
    .attr('x1', d => d.x1)
    .attr('y1', d => d.y1)
    .attr('x2', d => d.x2)
    .attr('y2', d => d.y2)
    .attr('stroke', 'black')
    .attr('stroke-width', 4);

